



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>KMP算法 hdu4686 Oulipo</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">KMP算法 hdu4686 Oulipo</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 15:12:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>Problem Description</div>
<div>The French author Georges Perec (1936&ndash;1982) once wrote a book, La disparition, without the letter 'e'. He was a member of the Oulipo group. A quote from the book:</p>
<p>Tout avait Pair normal, mais tout s&rsquo;affirmait faux. Tout avait Fair normal, d&rsquo;abord, puis surgissait l&rsquo;inhumain, l&rsquo;affolant. Il aurait voulu savoir o&ugrave; s&rsquo;articulait l&rsquo;association qui l&rsquo;unissait au roman : stir son tapis, assaillant &agrave; tout instant son imagination, l&rsquo;intuition d&rsquo;un tabou, la vision d&rsquo;un mal obscur, d&rsquo;un quoi vacant, d&rsquo;un non-dit : la vision, l&rsquo;avision d&rsquo;un oubli commandant tout, o&ugrave; s&rsquo;abolissait la raison : tout avait l&rsquo;air normal mais&hellip;</p>
<p>Perec would probably have scored high (or rather, low) in the following contest. People are asked to write a perhaps even meaningful text on some subject with as few occurrences of a given &ldquo;word&rdquo; as possible. Our task is to provide the jury with a program that counts these occurrences, in order to obtain a ranking of the competitors. These competitors often write very long texts with nonsense meaning; a sequence of 500,000 consecutive 'T's is not unusual. And they never use spaces.</p>
<p>So we want to quickly find out how often a word, i.e., a given string, occurs in a text. More formally: given the alphabet {'A', 'B', 'C', &hellip;, 'Z'} and two finite strings over that alphabet, a word W and a text T, count the number of occurrences of W in T. All the consecutive characters of W must exactly match consecutive characters of T. Occurrences may overlap.</p>
</div>
<div>&nbsp;</div>
<div>Input</div>
<div>The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:</p>
<p>One line with the word W, a string over {'A', 'B', 'C', &hellip;, 'Z'}, with 1 &le; |W| &le; 10,000 (here |W| denotes the length of the string W).<br />One line with the text T, a string over {'A', 'B', 'C', &hellip;, 'Z'}, with |W| &le; |T| &le; 1,000,000.</div>
<div>&nbsp;</div>
<div>Output</div>
<div>For every test case in the input file, the output should contain a single number, on a single line: the number of occurrences of the word W in the text T.</p>
</div>
<div>&nbsp;</div>
<div>Sample Input</div>
<div>
<div>3</div>
<div>BAPC
</div>
<div>BAPC
</div>
<div>AZA
</div>
<div>AZAZAZA
</div>
<div>VERDI
</div>
<div>AVERDXIVYERDIAN</div>
</div>
<div>&nbsp;</div>
<div>Sample Output</div>
<div>
<div>1</div>
<div>3
</div>
<div>0</p>
<div>
<pre class="prettyprint linenums"> #include &lt;stdio.h&gt;<br />
#include &lt;string.h&gt;

int next[];<br />
char str1[],str2[];<br />
int cnt;

void get_next(int len2)//生成next数组<br />
{<br />
    int i = ,j = -;<br />
    next[] = -;<br />
    while (i&lt;len2)<br />
    {<br />
        if(j == - || str2[i] == str2[j])<br />
        {<br />
            i++;<br />
            j++;<br />
            if (str2[i]!=str2[j])<br />
                next[i] = j;<br />
            else<br />
                next[i] = next[j];<br />
        }<br />
        else<br />
            j = next[j];<br />
    }<br />
}

int kmp(int len1,int len2)//kmp算法<br />
{<br />
    int i=,j=;<br />
    get_next(len2);<br />
    while(i&lt;len1)<br />
    {<br />
        if(j==-||str1[i]==str2[j])<br />
        {<br />
            ++i;<br />
            ++j;<br />
        }<br />
        else<br />
            j=next[j];<br />
        if(j == len2)<br />
        {<br />
            cnt++;<br />
            j = next[j];<br />
        }<br />
    }<br />
}

int main()<br />
{<br />
    int n;<br />
    int len1,len2;<br />
    scanf("%d",&amp;n);<br />
    getchar();<br />
    while(n--)<br />
    {<br />
        gets(str2);<br />
        gets(str1);<br />
        len1 = strlen(str1);<br />
        len2 = strlen(str2);<br />
        cnt = ;<br />
        kmp(len1,len2);<br />
        printf("%d\n",cnt);<br />
    }<br />
    return ;<br />
}</pre>
</div>
</div>
</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxex6v8.html">java向Excel文件写入数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnwv5gq.html">剑指Offer&colon;面试题30&mdash;&mdash;最小的k个数&lpar;java实现&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnzk0gq.html">Oracle 查看表空间的大小及使用情况sql语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9322kzq.html">LeetCode&lpar;&rpar; Ugly Number II   背下来！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1o2o39.html">Operation is not valid due to the current state of the object&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y6gxjq.html">Aizu 2306 Rabbit Party DFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m71n48.html">SGU 183&period; Painting the balls&lpar; dp &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp5mjj9.html">FFmpeg入门，简单播放器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1zjnmq.html">微信小程序统计分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozl3j8.html">Entity Framework 支持 DataTable</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e452oj9.html">FontAwesome图标选择器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r43x68.html">Golang实现杨辉三角</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e43vom9.html">python2的reload模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7d0vq.html">jdbcTemplate的简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e467le9.html">ionic tab显示到顶部去了</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2m3py9.html">实例&comma;C&num; 导出&period;dbf格式文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m23n3pq.html">尚硅谷springboot学习18-日志使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rwknj9.html">HTML  初识 HTML【 整体结构  文字 图片 表格 超链接】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpedyz9.html">【Android】开源项目汇总-备用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp5rj79.html">error processing package oracle-java8-installer问题解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rpg678.html">Mac系统下使用VirtualBox虚拟机安装win7－－第一步 安装vbox虚拟机</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqldj319.html">Page Object Model &lpar;Selenium&comma; Python&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxjow09.html">Unreal Engine4 学习笔记2 动画蒙太奇</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93rn4n9.html">POJ 1061 同余方程</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn6yex9.html">Effective C&plus;&plus; 之 0 导读（Introduction）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zp34d9.html">DateTime时间格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyngnd9.html">Codeforces Round &num;212 &lpar;Div&period; 2&rpar; D&period; Fools and Foolproof Roads 并查集&plus;优先队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k6r15q.html">ASP&period;NET MVC使用过滤器进行权限控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e6r1kq.html">【转】使用jquery animate创建平滑滚动效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g6r57q.html">this和super</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
